<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core">
<h:head>
    <h:outputStylesheet name="primeflex/primeflex.css" library="css"/>
    <h:outputStylesheet name="primeflex/themes/saga.css" library="css"/>
    <h:outputScript name="js/primeblocks.js"/>
</h:head>
<f:view>
    <div class="relative p-8 overflow-hidden">
        <p:graphicImage name="blocks/hero/hero-2.jpg" library="images" alt="Image"
                        styleClass="absolute top-0 left-0 w-auto h-full block md:w-full"/>

        <div class="text-center my-6 relative">
            <div class="text-6xl text-white font-bold mb-1">Memory management</div>
            <div class="text-6xl text-primary font-bold mb-4">Simulator</div>
            <p class="mt-0 mb-4 line-height-3 text-center mx-auto text-white"
               style="max-width:500px">This platform simulates the memory management performed by an operating system.</p>

            <div class="flex justify-content-center align-items-center m-4">
                <a href="https://www.github.com" class="text-white mr-3">
                    <i class="pi pi-github text-2xl"/>
                </a>
                <a href="https://play.google.com" class="text-white mr-3">
                    <i class="pi pi-amazon text-2xl"/>
                </a>
                <a href="https://www.facebook.com" class="text-white">
                    <i class="pi pi-facebook text-2xl"/>
                </a>
            </div>
        </div>
    </div>

    <h:form id="systemInfo">
        <p:panel id="control-btns" class="flex justify-content-center px-4 py-5 md:px-6 lg:px-8">
            <p:commandButton styleClass="mr-2 bg-blue-600 border-none" value="First"
                             actionListener="#{simulationController.setFirst}"
                             disabled="#{simulationController.isFirst()}"/>
            <p:commandButton styleClass="mr-2 bg-cyan-600 border-none" value="Previous"
                             actionListener="#{simulationController.previous}"
                             disabled="#{simulationController.isFirst()}"/>
            <p:commandButton styleClass="mr-2 bg-teal-600 border-none" value="Start" onclick="PF('poll').start();"
                             actionListener="#{simulationController.updateSystemInfo()}"
                             update="control-btns info running-process queued-process"
                             disabled="#{simulationController.isLast()}"
                             rendered="#{simulationController.stop}"/>
            <p:commandButton styleClass="mr-2 bg-teal-600 border-none" value="Stop" onclick="PF('poll').stop();"
                             actionListener="#{simulationController.stopSimulation}"
                             rendered="#{!simulationController.stop}" update="control-btns"/>
            <p:commandButton styleClass="mr-2 bg-cyan-600 border-none" value="Next"
                             actionListener="#{simulationController.next}"
                             disabled="#{simulationController.isLast()}"/>
            <p:commandButton styleClass="mr-2 bg-blue-600 border-none" value="Last"
                             actionListener="#{simulationController.setLast}"
                             disabled="#{simulationController.isLast()}"/>
        </p:panel>
        <p:poll interval="2" listener="#{simulationController.updateSystemInfo}"
                update="control-btns info running-process queued-process"
                widgetVar="poll" autoStart="false" stop="#{simulationController.stop}"/>

        <p:panel id="info" class="px-4 py-5 md:px-6 lg:px-8">
            <div class="grid">
                <div class="col-12 md:col-6 lg:col-3 p-3">
                    <div class="p-3 text-center bg-blue-500" style="border-radius: 12px">
                <span class="inline-flex justify-content-center align-items-center bg-blue-600 border-circle mb-3"
                      style="width:49px; height: 49px">
                    <i class="pi pi-inbox text-xl text-white"/>
                </span><br/>
                        <h:outputText class="text-2xl font-medium text-white mb-2"
                                      value="#{simulationController.currentInstantMemory.processesRunning.size()}"
                                      id="processRunning"/><br/>
                        <span class="text-blue-100 font-medium">Running process</span>
                    </div>
                </div>
                <div class="col-12 md:col-6 lg:col-3 p-3">
                    <div class="p-3 text-center bg-purple-500" style="border-radius: 12px">
                <span class="inline-flex justify-content-center align-items-center bg-purple-600 border-circle mb-3"
                      style="width:49px; height: 49px">
                    <i class="pi pi-map-marker text-xl text-white"/>
                </span><br/>
                        <h:outputText class="text-2xl font-medium text-white mb-2"
                                      value="#{simulationController.totalMemory - simulationController.currentInstantMemory.freeMemorySize}"
                                      id="totalMemory"/><br/>
                        <span class="text-purple-100 font-medium">Used memory</span>
                    </div>
                </div>
                <div class="col-12 md:col-6 lg:col-3 p-3">
                    <div class="p-3 text-center bg-indigo-500" style="border-radius: 12px">
                <span class="inline-flex justify-content-center align-items-center bg-indigo-600 border-circle mb-3"
                      style="width:49px; height: 49px">
                    <i class="pi pi-file text-xl text-white"/>
                </span><br/>
                        <h:outputText class="text-2xl font-medium text-white mb-2"
                                      value="#{simulationController.currentInstantMemory.clock}" id="clock"
                                      autoUpdate="true"/><br/>
                        <span class="text-indigo-100 font-medium">Clock</span>
                    </div>
                </div>
                <div class="col-12 md:col-6 lg:col-3 p-3">
                    <div class="p-3 text-center bg-orange-400" style="border-radius: 12px">
                <span class="inline-flex justify-content-center align-items-center bg-orange-600 border-circle mb-3"
                      style="width:49px; height: 49px">
                    <i class="pi pi-users text-xl text-white"/>
                </span><br/>
                        <h:outputText class="text-2xl font-medium text-white mb-2" id="free-memory"
                                      value="#{simulationController.currentInstantMemory.freeMemorySize}"/><br/>
                        <span class="text-orange-100 font-medium">Free Memory</span>
                    </div>
                </div>
            </div>
            <div class="p-grid mt-5">
                <div class="p-col-12 p-lg-6 p-xl-4">
                    <div class="card">
                        <p:donutChart id="graphic" model="#{simulationController.donutModel}"
                                      style="width: 100%; height: 500px;"/>
                    </div>
                </div>
            </div>
        </p:panel>

        <p:panel id="running-process" class="p-4 px-4 py-5 md:px-6 lg:px-8">
            <div class="flex align-items-center justify-content-between mb-4">
                <span class="text-xl font-medium text-900">Running process</span>
            </div>
            <div class="surface-border border-1 border-round p-3 mb-4">
                <span class="text-900 font-medium text-3xl">#{simulationController.getPercentage()}%
                    <span class="text-600">
                        (#{simulationController.totalMemory-simulationController.currentInstantMemory.freeMemorySize} MB/#{simulationController.totalMemory} MB)
                    </span>
                </span>
            </div>
            <ul class="mt-4 list-none p-0 mx-0">
                <li class="flex align-items-center pb-3">
                    <span class="text-xl font-medium text-90">Process</span>
                    <span class="text-600 text-xl font-medium ml-auto">Start location</span>
                    <span class="text-600 text-xl font-medium ml-auto">End location</span>
                    <span class="text-600 text-xl font-medium ml-auto">Life time</span>
                    <span class="text-600 text-xl font-medium ml-auto">Memory size</span>
                </li>
                <p:repeat value="#{simulationController.getProcess()}" var="process">
                    <li class="flex align-items-center pb-3">
                        <span style="width:1rem;height:1rem"
                              class="border-round #{process.color.getPrimeColor()} mr-3 flex-shrink-0"/>
                        <span class="text-xl font-medium text-90">#{process.process.getName()}</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{process.process.getStartLocation()} MB</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{process.process.getEndLocation()} MB</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{process.process.getTimeToFinish()} S</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{process.process.getSize()} MB</span>
                    </li>
                </p:repeat>
            </ul>
        </p:panel>

        <p:panel id="queued-process" class="p-4 px-4 py-5 md:px-6 lg:px-8">
            <div class="flex align-items-center justify-content-between mb-4">
                <span class="text-xl font-medium text-900">Queued process</span>
            </div>
            <ul class="mt-4 list-none p-0 mx-0">
                <li class="flex align-items-center pb-3">
                    <span class="text-xl font-medium text-90">Process</span>
                    <span class="text-600 text-xl font-medium ml-auto">Duration</span>
                    <span class="text-600 text-xl font-medium ml-auto">Memory size</span>
                </li>
                <p:repeat value="#{simulationController.currentInstantMemory.waitingProcess.queuedProcesses}"
                          var="processQueued">
                    <li class="flex align-items-center pb-3">
                        <span style="width:1rem;height:1rem"
                              class="lg:border-round bg-black-alpha-70 mr-3 flex-shrink-0"/>
                        <span class="text-xl font-medium text-90">#{processQueued.getName()}</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{processQueued.getDuration()} S</span>
                        <span class="text-600 text-xl font-medium ml-auto">#{processQueued.getSize()} MB</span>
                    </li>
                </p:repeat>
            </ul>
        </p:panel>
    </h:form>
</f:view>
</html>
